﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;

using System.Text;
using System.Windows.Forms;

using System.Data.SqlClient;

namespace myCode
{ 
    public partial class formConnection : Form
    {
        public formConnection()
        {
            InitializeComponent();
            InitialDBType();
        }

        #region 初始化数据库类型
        void InitialDBType()
        {
            this.cmbDBType.Items.AddRange(new string[] { "SqlServer2000", "SqlServer2005", "SqlServer2008" });
        }
        #endregion

        #region btnOk_Click
        private void btnOk_Click(object sender, EventArgs e)
        {
            if (this.cmbDBList.SelectedIndex == -1)
            {
                MessageBox.Show("请选择数据库");
                return;
            }            
            string strConnection = getConnecttionString(this.txtServerName.Text.Trim(), this.txtDBUserName.Text.Trim(), this.txtPwd.Text.Trim(), this.cmbDBList.SelectedItem.ToString().Trim());
            Form1.Connect = strConnection;
            this.Close();
        }
        #endregion

        #region 获取选择的数据库的字符串
        string getConnecttionString(string ServerName, string UserName, string Pwd, string DBName)
        {
            return "Data Source=" + ServerName + ";Initial Catalog=" + DBName + ";Persist Security Info=True;User ID=" + UserName + ";Password=" + Pwd + ";";
        }
        #endregion

        #region 获取master的连接字符串
        string getMastConnectionString(string servername,string username,string pwd)
        {
            return "Data Source=" + servername + ";Initial Catalog=Master;Persist Security Info=True;User ID=" + username + ";Password=" + pwd + ";";
        }
        #endregion

        #region formConnection_Load
        private void formConnection_Load(object sender, EventArgs e)
        {
            this.cmbValidateType.SelectedIndex = 0;
            this.cmbValidateType.Enabled = false;
        }
        #endregion

        #region button1_Click
        private void button1_Click(object sender, EventArgs e)
        {          
            //the dbtype
           if (this.cmbDBType.SelectedIndex ==-1)
            {
                MessageBox.Show("请选择数据库类型");
                return;
            }
            //validate the servername
            if (string.IsNullOrEmpty(this.txtServerName.Text.Trim()))
            {
                MessageBox.Show("请输入要连接的计算机名");
                return;
            }
            //validate the dbUid
            if (string.IsNullOrEmpty(this.txtDBUserName.Text.Trim()))
            {
                MessageBox.Show("请输入登录名");
                return;
            }
            //validate the pwd
            if (string.IsNullOrEmpty(this.txtPwd.Text.Trim()))
            {
                MessageBox.Show("请输入密码");
                return;
            }          

            try
            {   string dbtype = this.cmbDBType.SelectedText.Trim();
                string servername = this.txtServerName.Text.Trim();
                string username = this.txtDBUserName.Text.Trim();
                string pwd = this.txtPwd.Text.Trim();
                string dbname = this.cmbDBList.SelectedText.Trim();
                DBConnections db = new DBConnections(dbtype, servername, username, pwd, dbname);
                SqlConnection conn = new SqlConnection(getMastConnectionString(servername, username, pwd));
                SqlCommand comd = new SqlCommand("select * from sysdatabases", conn);
                SqlDataAdapter adapter = new SqlDataAdapter(comd);
                DataTable dt_list = new DataTable();
                adapter.Fill(dt_list);
                this.cmbDBList.Items.Clear();
                if (dt_list != null && dt_list.Rows.Count > 0)
                {
                    for (int i = 0; i < dt_list.Rows.Count; i++)
                    {
                        this.cmbDBList.Items.AddRange(new string[] { "" + dt_list.Rows[i][0].ToString() + "" });
                    }
                }
                MessageBox.Show("连接成功！请选择要连接的数据库！");
                this.cmbDBList.Focus();
                this.btnOk.Visible = true;
                this.btnCancel.Visible = true;
            }
            catch (Exception Ex)
            {
                MessageBox.Show(Ex.Message.ToString());     
                return;
            }
        }
        #endregion

        #region btnCancel_Click
        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.cmbValidateType.SelectedIndex = 0;
            this.cmbValidateType.Enabled = false;
            this.txtDBUserName.Text = string.Empty;
            this.txtPwd.Text = string.Empty;
            this.txtServerName.Text = string.Empty;
            this.cmbDBType.SelectedIndex = -1;
        }
        #endregion
    }
}
